unit UnitStopWatch;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls, Menus,
     Buttons;

type
  TFormStopWatch = class(TForm)
    Timer1: TTimer;
    ListView1: TListView;
    Label2: TLabel;
    Timer2: TTimer;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    procedure Timer1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure FormClick(Sender: TObject);
  private
    { Private declarations }
    procedure AddListViewItem;
    procedure CleanLabel2;
    procedure tglForm;
  public
    { Public declarations }
  end;

var
  FormStopWatch: TFormStopWatch;

implementation

{$R *.dfm}

procedure TFormStopWatch.Button1Click(Sender: TObject);
begin
  if Button1.Caption = 'ʼ' then
  begin
    Button1.Caption := 'ֹͣ';
    Button2.Caption := 'ƴ';
    Timer1.Enabled := True;
    Timer2.Enabled := True;
    // Button1.Color:=clRed;
  end
  else
  begin
    Button1.Caption := 'ʼ';
    Button2.Caption := 'λ';
    Timer1.Enabled := False;
    Timer2.Enabled := False;
   // Button1.Color:=clGreen;
  end;
end;

procedure TFormStopWatch.AddListViewItem;
var
  i: Integer;
begin

  i := ListView1.Items.Count + 1;
  with ListView1.Items.Add do
  begin
    Caption := IntToStr(i);
    SubItems.Add(Label2.Caption);
  end;
  SendMessage(ListView1.Handle, WM_VSCROLL, SB_BOTTOM, 0);
end;

var
  h: Integer = 0;
  m: Integer = 0;
  s: Integer = 0;

  h1: Integer = 0;
  m1: Integer = 0;
  s1: Integer = 0;

procedure TFormStopWatch.CleanLabel2;
begin
  if Button2.Caption = 'ƴ' then
  begin
    h := 0;
    m := 0;
    s := 0;
    Label2.Caption := Format('%.2d:%.2d:%.2d', [h, m, s]);
  end;

  if Button2.Caption = 'λ' then
  begin
    h := 0;
    m := 0;
    s := 0;

    h1 := 0;
    m1 := 0;
    s1 := 0;
    Label1.Caption := Format('%.2d:%.2d:%.2d', [h1, m1, s1]);
    Label2.Caption := Format('%.2d:%.2d:%.2d', [h, m, s]);
    ListView1.Clear;
  end;

end;

procedure TFormStopWatch.tglForm;
begin
  if Height = 341 then
    Height := 122
  else
    Height := 341;
end;

procedure TFormStopWatch.FormClick(Sender: TObject);
begin
  tglForm;
end;

procedure TFormStopWatch.Button2Click(Sender: TObject);
begin
  AddListViewItem;
  CleanLabel2;
end;

procedure TFormStopWatch.Timer1Timer(Sender: TObject);
begin
  inc(s1);
  if s1 >= 60 then
  begin
    inc(m1);
    s1 := 0;
  end;
  if m1 >= 60 then
  begin
    inc(h1);
    m1 := 0;
  end;
  Label1.Caption := Format('%.2d:%.2d:%.2d', [h1, m1, s1]);
end;

procedure TFormStopWatch.Timer2Timer(Sender: TObject);
begin
  inc(s);
  if s >= 60 then
  begin
    inc(m);
    s := 0;
  end;
  if m >= 60 then
  begin
    inc(h);
    m := 0;
  end;
  Label2.Caption := Format('%.2d:%.2d:%.2d', [h, m, s]);

end;

end.
