unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, MMSystem, Menus, ComCtrls,
  AppEvnts, Buttons, ExtActns, StdActns, ActnList, ToolWin;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    ComboBox1: TComboBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Label1: TLabel;
    Button4: TButton;
    ComboBox4: TComboBox;
    Button5: TButton;
    TabSheet4: TTabSheet;
    TrayIcon1: TTrayIcon;
    PopupMenu1: TPopupMenu;
    Update1: TMenuItem;
    N1: TMenuItem;
    Close1: TMenuItem;
    Image1: TImage;
    Button6: TButton;
    Label5: TLabel;
    ComboBox5: TComboBox;
    Label6: TLabel;
    btnStart: TButton;
    btnStop: TButton;
    Button7: TButton;
    Timer1: TTimer;
    Label7: TLabel;
    Button9: TButton;
    TimerKey1: TTimer;
    TimerKey2: TTimer;
    TimerKey3: TTimer;
    TimerKey4: TTimer;
    TimerKey5: TTimer;
    chkSelectAll: TCheckBox;
    TimerKey6: TTimer;
    TimerKey7: TTimer;
    TimerKey8: TTimer;
    TimerKey9: TTimer;
    GroupBox1: TGroupBox;
    cbbKey1: TComboBox;
    CheckBox1: TCheckBox;
    EditKey1: TEdit;
    cbbKey2: TComboBox;
    CheckBox2: TCheckBox;
    EditKey2: TEdit;
    cbbKey3: TComboBox;
    CheckBox3: TCheckBox;
    EditKey3: TEdit;
    cbbKey4: TComboBox;
    CheckBox4: TCheckBox;
    EditKey4: TEdit;
    cbbKey5: TComboBox;
    CheckBox5: TCheckBox;
    EditKey5: TEdit;
    cbbKey6: TComboBox;
    CheckBox6: TCheckBox;
    EditKey6: TEdit;
    cbbKey7: TComboBox;
    CheckBox7: TCheckBox;
    EditKey7: TEdit;
    cbbKey8: TComboBox;
    CheckBox8: TCheckBox;
    EditKey8: TEdit;
    cbbKey9: TComboBox;
    CheckBox9: TCheckBox;
    EditKey9: TEdit;
    LabelPosition: TLabel;
    Image2: TImage;
    Image3: TImage;
    TimerValue1: TTimer;
    Label2: TLabel;
    Label3: TLabel;
    TabSheet5: TTabSheet;
    PopupMenu2: TPopupMenu;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Delete1: TMenuItem;
    SelectAll1: TMenuItem;
    N2: TMenuItem;
    ReadOnly1: TMenuItem;
    N3: TMenuItem;
    RichEdit1: TRichEdit;
    ActionList1: TActionList;
    RichEditBold1: TRichEditBold;
    RichEditItalic1: TRichEditItalic;
    RichEditUnderline1: TRichEditUnderline;
    BOLD1: TMenuItem;
    ITALIC1: TMenuItem;
    UNDERLINE1: TMenuItem;
    Cut1: TMenuItem;
    EditCut1: TEditCut;
    EditCopy1: TEditCopy;
    EditPaste1: TEditPaste;
    EditSelectAll1: TEditSelectAll;
    Rnd1: TMenuItem;
    N4: TMenuItem;
    Save1: TMenuItem;
    CheckBox10: TCheckBox;
    CheckBox11: TCheckBox;
    TabSheet6: TTabSheet;
    CheckBox_Top: TCheckBox;
    ComboBox2: TComboBox;
    Button10: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure TrayIcon1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure Update1Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
    procedure btnStartClick(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure ComboBox5Change(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure TimerKey1Timer(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure TimerKey2Timer(Sender: TObject);
    procedure TimerKey3Timer(Sender: TObject);
    procedure TimerKey4Timer(Sender: TObject);
    procedure TimerKey5Timer(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure chkSelectAllClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure CheckBox7Click(Sender: TObject);
    procedure CheckBox8Click(Sender: TObject);
    procedure CheckBox9Click(Sender: TObject);
    procedure TimerKey6Timer(Sender: TObject);
    procedure TimerKey7Timer(Sender: TObject);
    procedure TimerKey8Timer(Sender: TObject);
    procedure TimerKey9Timer(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TimerValue1Timer(Sender: TObject);
    procedure ReadOnly1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure SelectAll1Click(Sender: TObject);
    procedure Rnd1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure RichEdit1Change(Sender: TObject);
    procedure CheckBox10Click(Sender: TObject);
    procedure CheckBox11Click(Sender: TObject);
    procedure CheckBox_TopClick(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Button10Click(Sender: TObject);
  private
    procedure CreateIniFile;
    procedure ReadConfig;
    procedure WriteConfig;

    procedure InstallHotKey;
    procedure UnInstallHotKey;
    procedure HotKeyDown(var Msg: TMessage);
    message WM_HOTKEY;
    function SendKey(Str: string): Integer;

    procedure SetIcon1;
    procedure SetIcon2;
    procedure SetMyCursor;
    procedure RestoreCursor;
    procedure SetLabelTimerProEnable;
    procedure SetLabelTimerProDisable;
    procedure UpdateCheckState();

    procedure OnMinsize(var msg: twmsyscommand);message wm_syscommand;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  HotKeyId, HotKeyId1: Integer;
  bCheck1State: Boolean;
  bCheck2State: Boolean;
  bCheck3State: Boolean;
  bCheck4State: Boolean;
  bCheck5State: Boolean;
  bCheck6State: Boolean;
  bCheck7State: Boolean;
  bCheck8State: Boolean;
  bCheck9State: Boolean;

implementation

{$R *.dfm}
{$R SpyRES.RES}

uses ShellApi, IniFiles, FileCtrl, Unit2, UnitStopWatch;

var
  IniFile: TIniFile;
  IniAbsFileName // 'iniľ·'
    : string;
  frm_StopWatch: TFormStopWatch;

  // ------------------------------------------------------------------------------

procedure TForm1.OnMinsize(var msg: twmsyscommand);
begin
  if msg.CmdType = SC_MINIMIZE then
  begin // ˴ӶС¼Ĵ
    Hide();
    msg.CmdType := SC_DEFAULT;
  end;
  inherited;
end;

procedure TForm1.InstallHotKey;
begin
  HotKeyId := GlobalAddAtom('MyHotKey');
  HotKeyId1 := GlobalAddAtom('MyHotKey1');

  RegisterHotKey(Handle, HotKeyId, MOD_ALT + MOD_CONTROL, VkKeyScan('x'));
  { Ctrl+Alt+x }
  RegisterHotKey(Handle, HotKeyId1, MOD_ALT + MOD_CONTROL, VkKeyScan('c'));
  { Ctrl+Alt+c }
end;

procedure TForm1.UnInstallHotKey;
begin
  UnRegisterHotKey(Handle, HotKeyId);
  UnRegisterHotKey(Handle, HotKeyId1);
  DeleteAtom(HotKeyId);
  DeleteAtom(HotKeyId1);
end;

procedure TForm1.HotKeyDown(var Msg: TMessage);
begin
  // start
  if (Msg.LparamLo = MOD_ALT + MOD_CONTROL) and (Msg.LParamHi = VkKeyScan('x'))
    then
    btnStart.Click;

  // stop
  if (Msg.LparamLo = MOD_ALT + MOD_CONTROL) and (Msg.LParamHi = VkKeyScan('c'))
    then
    btnStop.Click;
end;

// ------------------------------------------------------------------------------

var
  iniPath: string; // ini·
  fName: string; // iniļ
  // WriteString

procedure ComboBoxToINI(const AINIFile, ASection: string; ComboBox: TComboBox);
var
  INI: TIniFile;
  I: Integer;
begin
  INI := TIniFile.Create(AINIFile);
  try
    INI.EraseSection(ASection);
    INI.WriteInteger(ASection, 'Count', ComboBox.Items.Count);
    for I := 0 to ComboBox.Items.Count - 1 do
    begin
      INI.WriteString(ASection, 'Item' + IntToStr(I), ComboBox.Items[I]);
    end;
  finally
    INI.Free;
  end;
end;

// ReadString

procedure INIToComboBox(const AINIFile, ASection: string; ComboBox: TComboBox);
var
  INI: TIniFile;
  I, Count: Integer;
begin
  INI := TIniFile.Create(AINIFile);
  try
    Count := INI.ReadInteger(ASection, 'Count', 0);
    for I := 0 to Count - 1 do
    begin
      ComboBox.Items.Add(INI.ReadString(ASection, 'Item' + IntToStr(I), '0'));
    end;
  finally
    INI.Free;
  end;
end;

procedure TForm1.CreateIniFile;
begin
  IniAbsFileName := Application.ExeName + '.ini';
  IniFile := TIniFile.Create(IniAbsFileName);
end;

procedure TForm1.ReadConfig;
begin
  // ComboBox4.Text := IniFile.ReadString('MainForm', 'Ϸ·', 'D:\ʰ\element\elementclient.exe');
  INIToComboBox(IniAbsFileName, 'Ϸ·', ComboBox4);
  ComboBox4.ItemIndex := IniFile.ReadInteger('Ϸ·', 'ѡ', 0);

  INIToComboBox(IniAbsFileName, '޸Ĵб', ComboBox2);
  ComboBox2.ItemIndex := IniFile.ReadInteger('޸Ĵб', 'ѡ', 0);

  cbbKey1.ItemIndex := IniFile.ReadInteger('', '1', 0); // TAB
  cbbKey2.ItemIndex := IniFile.ReadInteger('', '2', 10); // f1
  cbbKey3.ItemIndex := IniFile.ReadInteger('', '3', 11); // f2
  cbbKey4.ItemIndex := IniFile.ReadInteger('', '4', 12); // f3
  cbbKey5.ItemIndex := IniFile.ReadInteger('', '5', 13); // f4

  cbbKey6.ItemIndex := IniFile.ReadInteger('', '6', 14); // f5
  cbbKey7.ItemIndex := IniFile.ReadInteger('', '7', 15); // f6
  cbbKey8.ItemIndex := IniFile.ReadInteger('', '8', 16); // f7
  cbbKey9.ItemIndex := IniFile.ReadInteger('', '9', 17); // f8

  EditKey1.Text := IniFile.ReadString('', '1', '1');
  EditKey2.Text := IniFile.ReadString('', '2', '2');
  EditKey3.Text := IniFile.ReadString('', '3', '1');
  EditKey4.Text := IniFile.ReadString('', '4', '5');
  EditKey5.Text := IniFile.ReadString('', '5', '5');
  EditKey6.Text := IniFile.ReadString('', '6', '5');
  EditKey7.Text := IniFile.ReadString('', '7', '5');
  EditKey8.Text := IniFile.ReadString('', '8', '5');
  EditKey9.Text := IniFile.ReadString('', '9', '5');

end;

procedure TForm1.WriteConfig;
begin

  IniFile.WriteInteger('', '1', cbbKey1.ItemIndex);
  IniFile.WriteInteger('', '2', cbbKey2.ItemIndex);
  IniFile.WriteInteger('', '3', cbbKey3.ItemIndex);
  IniFile.WriteInteger('', '4', cbbKey4.ItemIndex);
  IniFile.WriteInteger('', '5', cbbKey5.ItemIndex);

  IniFile.WriteInteger('', '6', cbbKey6.ItemIndex);
  IniFile.WriteInteger('', '7', cbbKey7.ItemIndex);
  IniFile.WriteInteger('', '8', cbbKey8.ItemIndex);
  IniFile.WriteInteger('', '9', cbbKey9.ItemIndex);

  IniFile.WriteString('', '1', EditKey1.Text);
  IniFile.WriteString('', '2', EditKey2.Text);
  IniFile.WriteString('', '3', EditKey3.Text);
  IniFile.WriteString('', '4', EditKey4.Text);
  IniFile.WriteString('', '5', EditKey5.Text);
  IniFile.WriteString('', '6', EditKey6.Text);
  IniFile.WriteString('', '7', EditKey7.Text);
  IniFile.WriteString('', '8', EditKey8.Text);
  IniFile.WriteString('', '9', EditKey9.Text);

  ComboBoxToINI(IniAbsFileName, 'Ϸ·', ComboBox4);
  IniFile.WriteInteger('Ϸ·', 'ѡ', ComboBox4.ItemIndex);

  ComboBoxToINI(IniAbsFileName, '޸Ĵб', ComboBox2);
  IniFile.WriteInteger('޸Ĵб', 'ѡ', ComboBox2.ItemIndex);

end;

// ַ

function GeneralPwd(StrLength: Integer; rType: Integer): string;
var
  I: Integer;
  Str, str1, str2, str3, reslt1: string;
begin
  str1 := '0123456789'; { ַ0~9 }
  str2 := 'abcdefghijklmnopqrstuvwxyz'; { ַa~z }
  str3 := 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'; { ַA~Z }
  Str := Str + str1 + str2 + str3;
  for I := 0 to StrLength - 1 do { ɵַ }
  begin
    case rType of
      0:
        reslt1 := reslt1 + str1[Random(Length(str1) - 1) + 1]; // 
      1:
        reslt1 := reslt1 + str2[Random(Length(str2) - 1) + 1]; // Сдĸ
      2:
        reslt1 := reslt1 + str3[Random(Length(str3) - 1) + 1]; // дĸ
      3:
        reslt1 := reslt1 + Str[Random(Length(Str) - 1) + 1]; // ĸ
    end;
  end;
  Result := reslt1;
end;

procedure RunGame(GamePath: string);
begin
  // path = "D:\Administrator\Documents\Games\ʰ\element\elementclient.exe"
  if not FileExists(GamePath) then
  begin
    Application.MessageBox('ļ' + #13#10, '뽫¼ϷĿ¼',
      MB_OK + MB_ICONERROR);
  end
  else
  begin
    ShellExecute(Application.Handle, 'open', PChar(GamePath), PChar(' game:cpw')
        , PChar(ExtractFilePath(GamePath)), SW_SHOW);
  end;
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
  ComboBox2.DeleteSelected;
  ComboBox2.ItemIndex := 0;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  h: Hwnd;
begin
  h := FindWindow(nil, PChar(ComboBox1.Text));
  if h > 0 then
  begin
    SetWindowText(h, PChar(ComboBox2.Text));
    if ComboBox2.Items.IndexOf(ComboBox2.Text) < 0 then
      ComboBox2.Items.Add(ComboBox2.Text);
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ComboBox2.Text := GeneralPwd(5, 3);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  WriteConfig;
  RunGame(ComboBox4.Text);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  // ==============================================================================
  frm_StopWatch := TFormStopWatch.Create(self);
  with frm_StopWatch do
  begin
    Parent := TabSheet6;
    BorderStyle := BsNone;
    Align := alClient;
    Show;
  end;
  // ==============================================================================
  ComboBox2.Text := GeneralPwd(5, 3);
  CreateIniFile;
  ReadConfig;
  Application.HintHidePause := 10000;
  InstallHotKey;

  Height := 161;
  // Width := 290;
  if ComboBox4.Text = '' then
    ComboBox4.Text := 'D:\ʰ\element\elementclient.exe';

  if not FileExists('ǩ.rtf') then
    RichEdit1.Lines.SaveToFile('ǩ.rtf')
  else
    RichEdit1.Lines.LoadFromFile('ǩ.rtf');
  UpdateCheckState();
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin

  UnInstallHotKey;
  RichEdit1.Lines.SaveToFile('ǩ.rtf');
  WriteConfig;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  with TOpenDialog.Create(nil) do
  begin
    Filter := 'elementclient.exe|*.exe';
    FileName := 'elementclient.exe';
    if Execute then
      ComboBox4.Text := FileName;
    if FileExists(FileName) then
      ComboBox4.Items.Add(FileName);
  end;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  ComboBox4.DeleteSelected;
  ComboBox4.ItemIndex := 0;
end;

procedure TForm1.TrayIcon1Click(Sender: TObject);
begin
  Visible := not Visible;
  if Visible = true then
    PageControl1.SetFocus;
end;

procedure TForm1.Close1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Update1Click(Sender: TObject);
begin
  ShellExecute(Handle, 'open', 'http://www.cnblogs.com/xe2011/p/3500516.html ',
    nil, nil, SW_SHOW);
end;

procedure swap(X, Y: string);
var
  temp: string;
begin
  temp := X;
  X := Y;
  Y := temp;
end;

procedure TForm1.Button6Click(Sender: TObject);
var
  a, b: string;
begin
  a := ComboBox1.Text;
  b := ComboBox2.Text; { ֵ }
  swap(a, b); { ֵԻ }
  ComboBox2.Text := a; { ȡֵ }
  ComboBox1.Text := b;
end;

procedure TForm1.btnStopClick(Sender: TObject);
begin
  btnStop.Enabled := False;
  btnStart.Enabled := true;
  Timer1.Enabled := False;
  ComboBox5.Enabled := true;
end;

procedure TForm1.btnStartClick(Sender: TObject);
begin
  btnStop.Enabled := true;
  btnStart.Enabled := False;
  Timer1.Enabled := true;
  ComboBox5.Enabled := False;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  Hide;
  ShowMessage('ҪλãȻʹÿݼ' + #13#10 + 'ʼ  Ctrl+Alt+X' + #13#10 +
      'ֹͣ  Ctrl+Alt+C');
  Show;
end;

procedure TForm1.ComboBox5Change(Sender: TObject);
begin
  Timer1.Interval := StrToInt(ComboBox5.Text);
end;

var
  Count: Integer = 0;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  mouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0); // 
  mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0); // 
  Inc(Count);
  Label7.Caption := Format(' %d ', [Count]);
end;

procedure TForm1.Timer2Timer(Sender: TObject);

begin

end;

// ģ

function TForm1.SendKey(Str: string): Integer;
var
  h: Hwnd;
  KeyValue: Integer;
begin
  { ģⷢͰ:1~9,F1~F9 }
  h := FindWindow('ElementClient Window', PChar(ComboBox1.Text));
  if Str = '1' then
    KeyValue := 49;
  if Str = '2' then
    KeyValue := 50;
  if Str = '3' then
    KeyValue := 51;
  if Str = '4' then
    KeyValue := 52;
  if Str = '5' then
    KeyValue := 53;
  if Str = '6' then
    KeyValue := 54;
  if Str = '7' then
    KeyValue := 55;
  if Str = '8' then
    KeyValue := 56;
  if Str = '9' then
    KeyValue := 57;
  if Str = 'F1' then
    KeyValue := VK_F1;
  if Str = 'F2' then
    KeyValue := VK_F2;
  if Str = 'F3' then
    KeyValue := VK_F3;
  if Str = 'F4' then
    KeyValue := VK_F4;
  if Str = 'F5' then
    KeyValue := VK_F5;
  if Str = 'F6' then
    KeyValue := VK_F6;
  if Str = 'F7' then
    KeyValue := VK_F7;
  if Str = 'F8' then
    KeyValue := VK_F8;
  if Str = 'F9' then
    KeyValue := VK_F9;
  if Str = 'Tab' then
    KeyValue := VK_Tab;

  Sendmessage(h, Wm_Keydown, KeyValue, 0);
  Sendmessage(h, Wm_Keyup, KeyValue, 0);
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
  Hide;
  ShowMessage('ǰ = "' + ComboBox1.Text + '"' + #13#10 +
      'ֻԵǰЧжͬһ򿪵ĴЧ');
  Show;
end;

procedure TForm1.TimerKey1Timer(Sender: TObject);
begin
  SendKey(cbbKey1.Text);
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.Checked then
  begin
    EditKey1.Enabled := False;
    cbbKey1.Enabled := False;
    TimerKey1.Enabled := true;
    TimerKey1.Interval := StrToInt(EditKey1.Text) * 1000;
  end
  else
  begin
    EditKey1.Enabled := true;
    cbbKey1.Enabled := true;
    TimerKey1.Enabled := False;
  end;
  UpdateCheckState();
end;

procedure TForm1.TimerKey2Timer(Sender: TObject);
begin
  SendKey(cbbKey2.Text);
end;

procedure TForm1.TimerKey3Timer(Sender: TObject);
begin
  SendKey(cbbKey3.Text);
end;

procedure TForm1.TimerKey4Timer(Sender: TObject);
begin
  SendKey(cbbKey4.Text);
end;

procedure TForm1.TimerKey5Timer(Sender: TObject);
begin
  SendKey(cbbKey5.Text);
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  if CheckBox2.Checked then
  begin
    EditKey2.Enabled := False;
    cbbKey2.Enabled := False;
    TimerKey2.Enabled := true;
    TimerKey2.Interval := StrToInt(EditKey2.Text) * 1000;
  end
  else
  begin
    EditKey2.Enabled := true;
    cbbKey2.Enabled := true;
    TimerKey2.Enabled := False;
  end;
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
  if CheckBox3.Checked then
  begin
    EditKey3.Enabled := False;
    cbbKey3.Enabled := False;
    TimerKey3.Enabled := true;
    TimerKey3.Interval := StrToInt(EditKey3.Text) * 1000;
  end
  else
  begin
    EditKey3.Enabled := true;
    cbbKey3.Enabled := true;
    TimerKey3.Enabled := False;
  end;
end;

procedure TForm1.CheckBox4Click(Sender: TObject);
begin
  if CheckBox4.Checked then
  begin
    EditKey4.Enabled := False;
    cbbKey4.Enabled := False;
    TimerKey4.Enabled := true;
    TimerKey4.Interval := StrToInt(EditKey4.Text) * 1000;
  end
  else
  begin
    EditKey4.Enabled := true;
    cbbKey4.Enabled := true;
    TimerKey4.Enabled := False;
  end;
end;

procedure TForm1.CheckBox5Click(Sender: TObject);
begin
  if CheckBox5.Checked then
  begin
    EditKey5.Enabled := False;
    cbbKey5.Enabled := False;
    TimerKey5.Enabled := true;
    TimerKey5.Interval := StrToInt(EditKey5.Text) * 1000;
  end
  else
  begin
    EditKey5.Enabled := true;
    cbbKey5.Enabled := true;
    TimerKey5.Enabled := False;
  end;
end;

procedure TForm1.chkSelectAllClick(Sender: TObject);
begin
  CheckBox1.Checked := chkSelectAll.Checked;
  CheckBox2.Checked := chkSelectAll.Checked;
  CheckBox3.Checked := chkSelectAll.Checked;
  CheckBox4.Checked := chkSelectAll.Checked;
  CheckBox5.Checked := chkSelectAll.Checked;
  CheckBox6.Checked := chkSelectAll.Checked;
  CheckBox7.Checked := chkSelectAll.Checked;
  CheckBox8.Checked := chkSelectAll.Checked;
  CheckBox9.Checked := chkSelectAll.Checked;
  UpdateCheckState();
end;

procedure TForm1.UpdateCheckState();
begin
  bCheck1State := CheckBox1.Checked;
  bCheck2State := CheckBox2.Checked;
  bCheck3State := CheckBox3.Checked;
  bCheck4State := CheckBox4.Checked;
  bCheck5State := CheckBox5.Checked;
  bCheck6State := CheckBox6.Checked;
  bCheck7State := CheckBox7.Checked;
  bCheck8State := CheckBox8.Checked;
  bCheck9State := CheckBox9.Checked;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  ShowWindow(Application.Handle, SW_HIDE);
  // alt+tabг
end;

procedure TForm1.CheckBox6Click(Sender: TObject);
begin
  if CheckBox6.Checked then
  begin
    EditKey6.Enabled := False;
    cbbKey6.Enabled := False;
    TimerKey6.Enabled := true;
    TimerKey6.Interval := StrToInt(EditKey6.Text) * 1000;
  end
  else
  begin
    EditKey6.Enabled := true;
    cbbKey6.Enabled := true;
    TimerKey6.Enabled := False;
  end;
end;

procedure TForm1.CheckBox7Click(Sender: TObject);
begin
  if CheckBox7.Checked then
  begin
    EditKey7.Enabled := False;
    cbbKey7.Enabled := False;
    TimerKey7.Enabled := true;
    TimerKey7.Interval := StrToInt(EditKey7.Text) * 1000;
  end
  else
  begin
    EditKey7.Enabled := true;
    cbbKey7.Enabled := true;
    TimerKey7.Enabled := False;
  end;
end;

procedure TForm1.CheckBox8Click(Sender: TObject);
begin
  if CheckBox8.Checked then
  begin
    EditKey8.Enabled := False;
    cbbKey8.Enabled := False;
    TimerKey8.Enabled := true;
    TimerKey8.Interval := StrToInt(EditKey8.Text) * 1000;
  end
  else
  begin
    EditKey8.Enabled := true;
    cbbKey8.Enabled := true;
    TimerKey8.Enabled := False;
  end
end;

procedure TForm1.CheckBox9Click(Sender: TObject);
begin
  if CheckBox9.Checked then
  begin
    EditKey9.Enabled := False;
    cbbKey9.Enabled := False;
    TimerKey9.Enabled := true;
    TimerKey9.Interval := StrToInt(EditKey9.Text) * 1000;
  end
  else
  begin
    EditKey9.Enabled := true;
    cbbKey9.Enabled := true;
    TimerKey9.Enabled := False;
  end
end;

procedure TForm1.CheckBox_TopClick(Sender: TObject);
var
  h: Hwnd;
  state: Integer;
begin
  if CheckBox_Top.Checked then
    state := HWND_TOPMOST
  else
    state := HWND_NOTOPMOST;

  h := FindWindow(nil, PChar(ComboBox1.Text));
  SetWindowPos(h, state, 0, 0, 0, 0, SWP_NOMOVE + SWP_NOSIZE);
end;

procedure TForm1.TimerKey6Timer(Sender: TObject);
begin
  SendKey(cbbKey6.Text);
end;

procedure TForm1.TimerKey7Timer(Sender: TObject);
begin
  SendKey(cbbKey7.Text);
end;

procedure TForm1.TimerKey8Timer(Sender: TObject);
begin
  SendKey(cbbKey8.Text);
end;

procedure TForm1.TimerKey9Timer(Sender: TObject);
begin
  SendKey(cbbKey9.Text);
end;

procedure TForm1.PageControl1Change(Sender: TObject);
begin
  case PageControl1.TabIndex of
    0:
      Height := 161;
    1:
      Height := 161;
    2:
      Height := 313;
    3:
      Height := 161;
    4:
      Height := 313;
    5:
      Height := 313;
  end;
end;

//
// ------------------------------------------------------------------------------

procedure TForm1.SetIcon1;
begin
  Form1.Image1.Picture := Image2.Picture;

end;

procedure TForm1.SetIcon2;
begin
  Form1.Image1.Picture := Image3.Picture;
end;

procedure TForm1.SetMyCursor;
var
  h: HCURSOR;
begin
  h := LoadCursor(HInstance, 'DragCursor');
  SetSystemCursor(h, ocr_normal);
end;

procedure TForm1.RestoreCursor;
begin
  SystemParametersinfo(SPI_SETCURSORS, 0, nil, SPIF_SENDCHANGE);
end;

procedure TForm1.SetLabelTimerProEnable;
begin
  LabelPosition.Caption := '';
  LabelPosition.Visible := true;
  TimerValue1.Enabled := true;
end;

procedure TForm1.SetLabelTimerProDisable;
begin
  LabelPosition.Visible := False;
  TimerValue1.Enabled := False;
end;

//

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  SetIcon2;
  SetMyCursor;
  SetLabelTimerProEnable;
end;

procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  SetIcon1;
  RestoreCursor;
  SetLabelTimerProDisable;
end;

procedure TForm1.TimerValue1Timer(Sender: TObject);
var
  h: Hwnd;
  p: TPoint;
  Rec: TRect;
  sClassName, sWindowText: array [0 .. 254] of Char;
begin
  GetCursorPos(p);
  LabelPosition.Caption := Format('%d,%d', [p.X, p.Y]);
  h := WindowFromPoint(p);
  GetClassName(h, sClassName, SizeOf(sClassName));
  GetWindowText(h, sWindowText, SizeOf(sClassName));

  ComboBox1.Text := sWindowText;
end;

procedure TForm1.ReadOnly1Click(Sender: TObject);
begin
  RichEdit1.ReadOnly := ReadOnly1.Checked;
  Cut1.Visible := not RichEdit1.ReadOnly;
  Paste1.Visible := not RichEdit1.ReadOnly;
  Delete1.Visible := not RichEdit1.ReadOnly;
  Save1.Visible := not RichEdit1.ReadOnly;
  if RichEdit1.ReadOnly then
  begin
    RichEdit1.Color := clMenuBar;
  end
  else
  begin
    RichEdit1.Color := clWindow;
  end;
end;

procedure TForm1.Delete1Click(Sender: TObject);
begin
  RichEdit1.SelText := '';
end;

procedure TForm1.SelectAll1Click(Sender: TObject);
begin
  RichEdit1.SelectAll;
end;

procedure TForm1.Rnd1Click(Sender: TObject);
begin
  Hide;
  Form2.ShowModal;
end;

procedure TForm1.Save1Click(Sender: TObject);
begin
  RichEdit1.Lines.SaveToFile('ǩ.rtf');
  Save1.Enabled := False;
end;

procedure TForm1.RichEdit1Change(Sender: TObject);
begin
  Save1.Enabled := RichEdit1.Modified;
end;

procedure TForm1.CheckBox10Click(Sender: TObject);
begin
  CheckBox1.Checked := not CheckBox1.Checked;
  CheckBox2.Checked := not CheckBox2.Checked;
  CheckBox3.Checked := not CheckBox3.Checked;
  CheckBox4.Checked := not CheckBox4.Checked;
  CheckBox5.Checked := not CheckBox5.Checked;
  CheckBox6.Checked := not CheckBox6.Checked;
  CheckBox7.Checked := not CheckBox7.Checked;
  CheckBox8.Checked := not CheckBox8.Checked;
  CheckBox9.Checked := not CheckBox9.Checked;
end;

procedure TForm1.CheckBox11Click(Sender: TObject);
begin
  if bCheck1State = true then
    CheckBox1.Checked := not CheckBox1.Checked;
  //
  // CheckBox1.Checked :=not  bCheck1State;
  // CheckBox2.Checked :=not  bCheck2State;
  // CheckBox3.Checked :=not  bCheck3State;
  // CheckBox4.Checked :=not  bCheck4State;
  // CheckBox5.Checked :=not  bCheck5State;
  // CheckBox6.Checked :=not  bCheck6State;
  // CheckBox7.Checked :=not  bCheck7State;
  // CheckBox8.Checked :=not  bCheck8State;
  // CheckBox9.Checked :=not  bCheck9State;

end;

end.
